// XML to GUIDO Parser by Andreas Berndt v.1.0
// Build on Expat 
//
// xml2guido.cpp (main functions to convert xml -> guido)
//
// This file contains the implementation of the callback functions,
// wich will be called from the parser. Furthermore
// we have some basic file-operations to handle the output file-stream.
//

#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <stdio.h>
#include "taglist.h"
#include "expat.h"
 
// Globals!

#define BUFFSIZE	8192

XML_Parser p; // the parser-object
int col = 0; // counter for coloumn-depth, if col is >= 80 then print a linefeed
int is_ambigous = 0; //checks tags like fermata
int in_brackets = 0; // are there brackets ??
int found_unknown = 0; //flag for unknown tags
char Buff[BUFFSIZE];
FILE *gmn_datei; // filepointer for gmn-file
FILE *unknown_tags; // filepointer for unknown-tags-file
char check_last_sequence[BUFFSIZE];

//--------------------------------------------------------------------------------------

// function noa gives the number of parameters of the actual tag
int noa (const char* const givenTag) {
  char buf[256]; 
  buf[0] = '\0';
  char* buf_ptr = buf;
  strcpy (buf_ptr, givenTag);
	int result = 0;
	
	while ((buf_ptr = strchr(buf_ptr,':'))){
		result++;
		buf_ptr = buf_ptr+1;
	}

	result = result - 2;
	return result;
}

//--------------------------------------------------------------------------------------

// functions get123 returns the value of a parameter at position pos
// in the tag-table, which is declared in taglist.h
char *get123 (char *retstring, int retstrlength, const char* const givenTag, int pos) {

	char buf_tmp[256];
    char *buf = buf_tmp;

	strcpy(buf,givenTag);
	int givenLength = strlen(givenTag);

	char *pos1 = buf;
	char *pos2 = NULL;

	int i = 1;

	do
	{
		char *ret = NULL;
		
		if ( (ret = strchr(pos1,':')) != NULL)
		{
			pos2 = ret;
			
			if (i==pos)
			{
				strncpy(retstring,pos1,(int) (pos2-pos1));
				retstring[ (int) (pos2-pos1) ] = 0;
				return retstring;
			}
			pos1 = pos2 + 1;
			if ( (int) (pos1 - givenTag) > givenLength)
				return NULL;
			pos2 = NULL;
			
		}
		if (i == pos && pos2 == NULL)
		{
			strcpy(retstring,pos1);
			return retstring;
				
		}
		i++;

	}
	while (i<= pos);


	return NULL;

	/* old stuff
  char *result_buf = retstring;

	strcpy (buf, givenTag);
	int given_length = strlen(buf);
	int len_buf = 0;
	result_buf[0] = '\0';


	for (int i=1; i <= pos; i++) {
		
		
		while (len_buf < given_length && buf[len_buf] != ':') {
		len_buf++;
		}

		if (len_buf >= given_length)
		{
			strcpy(retstring,"");
			return retstring;
		}
		
		result_buf = strncpy (result_buf, buf, len_buf);
		result_buf[len_buf] = '\0';
		len_buf=0;
		buf = strchr(buf,':');
		buf = buf+1;
		
	}
	return result_buf;
	*/ 
}

//--------------------------------------------------------------------------------------

//function filter filters out the given parameters in taglist.h
int filter (const char *check, const char* const givenTag) {
int result = 0;
	for (int o = 1;o <= noa(givenTag) ;o++){
		char buf[256];
		if (!strcmp(check, get123(buf,256,givenTag,o+3))) {
			result = 1;
			break;
		}
		
	}
	
	return result;
}

//--------------------------------------------------------------------------------------

//function unbracketed works with signed-u-tags
void unbracketed (const char *name, const char **attr, const char* const givenTag) {
int attr_count;

if (!in_brackets && !is_ambigous) {fprintf (gmn_datei, "\n"); col = 0;}
if (in_brackets && col >= 80) { fprintf (gmn_datei, "\n"); col = 0; }
if (is_ambigous) { fprintf(gmn_datei,"("); is_ambigous = 0; in_brackets = 1; col++;}
else
if (attr[0] && !strcmp(attr[0], "id")){
			fprintf(gmn_datei, " \\%s:%s",name ,  attr[1]);
			col = col + strlen(name) + 2 + strlen(attr[1]); // Add tagname and id to coloumn
			if (attr[2]) { fprintf(gmn_datei, "<"); 
				col++; // Add < to coloumn
				for (attr_count = 2; attr[attr_count]; attr_count +=2) { 

					if (filter(attr[attr_count],givenTag)) {  fprintf(gmn_datei, "%s", attr[attr_count + 1]); col = col + strlen(attr[attr_count + 1]);}
					else {fprintf(gmn_datei, "%s=%s", attr[attr_count], attr[attr_count + 1]); col = col + strlen(attr[attr_count]) + strlen(attr[attr_count + 1]) + 1;}

					if (attr[attr_count + 2] != NULL) { fprintf(gmn_datei, ","); col++;}
				}    	     
				fprintf(gmn_datei, "> ");
				col++;
			}
}
 
 else {

			fprintf(gmn_datei, " \\%s", name);
			col = col + strlen(name) + 2; // Add tagname to coloumn
			if (attr[0]) { fprintf(gmn_datei, "<");
				col++; // Add < to coloumn
				for (attr_count = 0; attr[attr_count]; attr_count +=2) { 

					if (filter(attr[attr_count],givenTag)) {  fprintf(gmn_datei, "%s", attr[attr_count + 1]); col = col + strlen(attr[attr_count + 1]);}
					else {fprintf(gmn_datei, "%s=%s", attr[attr_count], attr[attr_count + 1]); col = col + strlen(attr[attr_count]) + strlen(attr[attr_count + 1]) + 1;}
				
					if (attr[attr_count + 2] != NULL) { fprintf(gmn_datei, ","); col++;}
				}    	     
				fprintf(gmn_datei, "> ");
				col++;
			}
			else { fprintf(gmn_datei, " "); col++; }
 }
 
}; // End of unbracketed

//--------------------------------------------------------------------------------------

//function bracketed works with signed-b-tags
void bracketed (const char *name, const char **attr, const char* const givenTag) {

if (!in_brackets && !is_ambigous) {fprintf (gmn_datei, "\n"); col=0;}	
in_brackets = 1;
int attr_count;

if (is_ambigous) { fprintf(gmn_datei,"("); is_ambigous = 0; col++;}

fprintf(gmn_datei, " \\%s", name);
col = col + strlen(name) + 2;
 if (attr[0]) { fprintf(gmn_datei, "<"); 
 col++;
 for (attr_count = 0; attr[attr_count]; attr_count +=2) { 

	if (filter(attr[attr_count], givenTag)) {  fprintf(gmn_datei, "%s", attr[attr_count + 1]); col = col + strlen(attr[attr_count + 1]);}
	else {fprintf(gmn_datei, "%s=%s", attr[attr_count], attr[attr_count + 1]); col = col + strlen(attr[attr_count + 1]) + strlen(attr[attr_count]) + 1;}
 
		if (attr[attr_count + 2] != NULL) { fprintf(gmn_datei, ","); col++;}
	}    	     
	fprintf(gmn_datei, ">");
	col++;
 }
fprintf(gmn_datei, "(");
col++;

}; //End of bracketed

//--------------------------------------------------------------------------------------

//function brackUnbrack works with signed-a-tags
void brackUnbrack (const char *name, const char **attr,const char* const givenTag) {
int attr_count;

if (!in_brackets && !is_ambigous) {fprintf (gmn_datei, "\n"); col=0;}
fprintf(gmn_datei, " \\%s", name);
col = col + strlen(name) + 2;
if (attr[0]) { fprintf(gmn_datei, "<"); 
	col++;
	for (attr_count = 0; attr[attr_count]; attr_count +=2) { 

		if (filter(attr[attr_count],givenTag)) {  fprintf(gmn_datei, "%s", attr[attr_count + 1]); col = col + strlen(attr[attr_count + 1]);}
		else {fprintf(gmn_datei, "%s=%s", attr[attr_count], attr[attr_count + 1]); col = col + strlen(attr[attr_count + 1]) + strlen(attr[attr_count]) + 1;}

		if (attr[attr_count + 2] != NULL) { fprintf(gmn_datei, ","); col++;}
	}    	     
	fprintf(gmn_datei, "> ");
	col++;
}

is_ambigous = 1;

} // End of brackUnbrack

//--------------------------------------------------------------------------------------

//function end_bracketed shows how to handle with end of bracketed tags
void end_bracketed () {
	in_brackets = 0;
	fprintf(gmn_datei, ")");
	col++;
	
} //End of end_bracketed

//--------------------------------------------------------------------------------------

//function end_brackUnbrack shows how to handle with end of ambigous tags
void end_brackUnbrack () {

if (!is_ambigous) { fprintf(gmn_datei,")"); col++;}
else { fprintf(gmn_datei, " "); col++;}
is_ambigous = 0;


} //End of end_brackUnbrack

//--------------------------------------------------------------------------------------

//function start handles all start-tags
void start(void *data, const char *el, const char **attr) {

	int found_in_for = 0;

	char attr_temp[100][100]; 
	int schleife1; 
	for (schleife1 = 0; schleife1 < 100; schleife1++) { 
	    attr_temp[schleife1][0] = '\0';} 
	 
	int attr_count;  

	for (int u = 0;tags[u] != "#";u++) {
		char mybuf[256];
		if (!strcmp(el, get123(mybuf,256,tags[u],1))) {
			found_in_for = 1;
			if (!strcmp("u", get123(mybuf,256,tags[u],2))) {
				unbracketed (get123(mybuf,256,tags[u],3),attr,tags[u]);
			}
			else if (!strcmp("b", get123(mybuf,256,tags[u],2))) {
				bracketed (get123(mybuf,256,tags[u],3),attr, tags[u]);
			}
			else if (!strcmp("a", get123(mybuf,256,tags[u],2))) {
				brackUnbrack (get123(mybuf,256,tags[u],3),attr,tags[u]);
			}
			break;
		}
	}

	//segment
	if (!strcmp(el, "segment")){fprintf(gmn_datei, "{");}

	//sequence
	else if (!strcmp(el, "sequence") && strcmp(check_last_sequence, "sequence")){fprintf(gmn_datei, "[");} 
	else if (!strcmp(el, "sequence") && !strcmp(check_last_sequence, "sequence")){fprintf(gmn_datei, ",\n[");}  

	//note
	else if (!strcmp(el, "note")){ 

	  if (is_ambigous) { fprintf(gmn_datei,"("); is_ambigous = 0; col++;}
	  if (in_brackets && col >= 80) { fprintf(gmn_datei, "\n"); fprintf (gmn_datei, " ");col = 1; }
	    for (attr_count = 0; attr[attr_count]; attr_count +=2) { 
		if (attr[attr_count] != NULL && !strcmp(attr[attr_count], "name")){ strcpy(attr_temp[0],attr[attr_count + 1]);col=col + strlen(attr[attr_count + 1]);} 
		else if (attr[attr_count] != NULL && !strcmp(attr[attr_count], "accidentals")){ 
		    if (!strcmp(attr[attr_count + 1],"0")){ attr_temp[1][0]='\0';} 
		    else if(!strcmp(attr[attr_count + 1],"#")){ sprintf(attr_temp[1], "#"); col++;} 
		    else if(!strcmp(attr[attr_count + 1],"b")){ sprintf(attr_temp[1], "&"); col++;} 
		    } 
		else if (attr[attr_count] != NULL && !strcmp(attr[attr_count], "octave")){ strcpy(attr_temp[2],attr[attr_count + 1]); col=col + strlen(attr[attr_count + 1]);} 
		else if (attr[attr_count] != NULL && !strcmp(attr[attr_count], "duration")){ strcpy(attr_temp[4],attr[attr_count + 1]);strcpy(attr_temp[3],"*"); col = col + 1 + strlen(attr[attr_count]);} 
	    }    	     
	    strcpy(attr_temp[5], " ");
		col++;
	    for  (attr_count = 0; attr_count < 10; attr_count++){ 
		fprintf(gmn_datei, attr_temp[attr_count]); 
		
		} 
		
		
	} //end note

	//rest
	else if (!strcmp(el, "rest")){

	  if (is_ambigous) { fprintf(gmn_datei,"("); is_ambigous = 0; col++;}
	  if (in_brackets && col >= 80) { fprintf(gmn_datei, "\n"); col = 0; }

	  fprintf(gmn_datei, "_*%s ", attr[1]);
	  col = col + 2 + strlen(attr[1]);
	}
	
	//chord
	else if (!strcmp(el, "chord")){
	  
	  if (is_ambigous) { fprintf(gmn_datei,"("); is_ambigous = 0; col++;}

	  fprintf(gmn_datei, "{");
	  col++;
	}
	
	//comment
	else if (!strcmp(el, "comment")){
		fprintf(gmn_datei, " %%");
		if (attr[0]) { fprintf(gmn_datei, attr[1]); fprintf(gmn_datei, "\n"); }
		else { fprintf(gmn_datei, " "); }
	}	

	// guido 
	else if (!strcmp(el, "guido")){}

	//all other Tags
    else if(!found_in_for) {
		found_in_for = 0;
		if (!in_brackets && !is_ambigous) {fprintf (gmn_datei, "\n"); col = 0;}
		if (in_brackets && col >= 80) { fprintf (gmn_datei, "\n"); col = 0; }
		fprintf (unknown_tags, "\nUnknown Tag %s found in line %i.",el, XML_GetCurrentLineNumber(p));
		found_unknown = 1;
		fprintf(gmn_datei, " \\%s", el);
		col = col + strlen(el) + 2;
		if (attr[0]) { fprintf(gmn_datei, "<"); 
			col++;
			for (attr_count = 0; attr[attr_count]; attr_count +=2) { 
				if ((attr[attr_count][0] == 100 && (attr[attr_count][1] == 120 || attr[attr_count][1] == 121) && 
				     (attr[attr_count][2]>=48 && attr[attr_count][2] <=57)) || 
				    (attr[attr_count][0] == 104 || attr[attr_count][0] == 115 || 
				     attr[attr_count][0] == 105 || attr[attr_count][0] == 117 || attr[attr_count][0] == 114) && 
				    (attr[attr_count][1] == '\0' || (attr[attr_count][1]>=48 && attr[attr_count][1] <=57))){
					fprintf(gmn_datei, "%s", attr[attr_count + 1]);
					col = col + strlen(attr[attr_count + 1]);}
				else { 
					fprintf(gmn_datei, "%s=%s", attr[attr_count], attr[attr_count + 1]);
					col = col + strlen(attr[attr_count]) + strlen(attr[attr_count * 1]) + 1;}
				if (attr[attr_count + 2] != NULL) { fprintf(gmn_datei, ","); col++;}
			}    	     
			fprintf(gmn_datei, "> ");
			col++;
		}
		else { 
			fprintf(gmn_datei, " ");
			col++;
		}
	}	
	
}  /* End of start handler */

//--------------------------------------------------------------------------------------

//function end handles all end-tags
void end(void *data, const char *el) {
	
	strcpy(check_last_sequence,el); 
	 
	for (int u = 0;tags[u] != "#";u++) {
		char mybuf[256];
		if (!strcmp(el, get123(mybuf,256,tags[u],1))) {
			if (!strcmp("b", get123(mybuf,256,tags[u],2))) {
				end_bracketed ();
			}
			else if (!strcmp("a", get123(mybuf,256,tags[u],2))) {
				end_brackUnbrack ();
			}
			break;
		}
	}

	//segment
	if (!strcmp(el, "segment")){fprintf(gmn_datei, "}\n");}
		
	 
	//sequence
	else if (!strcmp(el, "sequence")){fprintf(gmn_datei, "]\n");}

	//chord
	else if (!strcmp(el, "chord")){
		fprintf(gmn_datei, "} ");}

}  /* End of end handler */

//--------------------------------------------------------------------------------------

// the main function, opens all input and output streams and
// starts the evaluation of the xml-data-stream
int main(int argc, char *argv[]) {
  
	FILE *xml_datei;
	
	char xml_datei_name[256], gmn_datei_name[256], unknown_tags_name[256];
	
	int write_error;

	printf ("XML-to-GUIDO Parser 1.0\n\n");
	if (argc <= 1) {
		printf ("Usage is: xml2guido xml_file.xml\n\n");
		exit(0);
	}

	if (!strcmp(argv[1], "?")) {
		printf ("Usage is xml2guido xml_file.xml\n\n");
		exit(0);
	}

	char* to_dot;             // pointer for string operations
	

	strcpy(xml_datei_name, argv[1]);
	strcpy(gmn_datei_name, xml_datei_name);
	strcpy(unknown_tags_name, xml_datei_name);
  
	// find the first dot of actual xml_datei_name and write the xml-ending behind,
	// if there's no dot then append the xml-ending
	if (!(to_dot = strrchr(xml_datei_name, '.'))){ strcat (unknown_tags_name, ".uts");strcat(gmn_datei_name, ".gmn");}
	else { 
	  strncat(gmn_datei_name, xml_datei_name, to_dot-xml_datei_name);       
	  strncat(unknown_tags_name, xml_datei_name, to_dot-xml_datei_name);       
	  gmn_datei_name[to_dot-xml_datei_name] = '\0';
	  unknown_tags_name[to_dot-xml_datei_name] = '\0';
	  strcat(gmn_datei_name, ".gmn");
	  strcat(unknown_tags_name, ".uts");
	}

	unknown_tags = fopen(unknown_tags_name, "w");

	printf("\nwriting '%s'.\n", gmn_datei_name); fflush(stdout);

	if (!(to_dot = strchr(xml_datei_name, '.'))) strcat(xml_datei_name, ".xml");
	
	if ((xml_datei = fopen (xml_datei_name, "r")) == NULL)
	{
		printf("File does not exist or is written wrong... program termination!");
		exit(1);
	}
	
	gmn_datei = fopen (gmn_datei_name, "w");
	if ((write_error = fprintf(gmn_datei, "%% Parsed by XML-to-GUIDO Parser 1.0 \n\n")) == 0){
		fprintf(stderr, "Error writing the GMN-File\n");
	}
	
	p = XML_ParserCreate(NULL);
  if (! p) {
    fprintf(stderr, "Couldn't allocate memory for parser\n");
    exit(-1);
  }

  XML_SetElementHandler(p, start, end);
  
  for (;;) {
	  
	  int bytes_read;
	  void *buff = XML_GetBuffer(p, BUFFSIZE);
	  if (buff == NULL) {
		  /* handle error */
	  }
	  
	  bytes_read = fread(buff, 1, BUFFSIZE,xml_datei);
	  if (bytes_read < 0) {
		  /* handle error */
		  fprintf(stderr, "Read error\n");
		  exit(-1);
	  }
	  
	  if (! XML_ParseBuffer(p, bytes_read, bytes_read == 0)) {
		  /* handle parse error */
		  fprintf(stderr, "Parse error at line %d:\n%s\n",
			  XML_GetCurrentLineNumber(p),
			  XML_ErrorString(XML_GetErrorCode(p)));
		  exit(-1);
	  }
	  
	  if (bytes_read == 0)
		  break;
	  //    len = fread(Buff, 1, BUFFSIZE, xml_datei);
	  //    if (ferror(xml_datei)) {
	  //   }
	  //   done = feof(xml_datei);
	  
	  //  if (! XML_Parse(p, Buff, len, done)) {
	  //     fprintf(stderr, "Parse error at line %d:\n%s\n",
	  //	      XML_GetCurrentLineNumber(p),
	  //	      XML_ErrorString(XML_GetErrorCode(p)));
	  //    exit(-1);
	  //}
	  
	  //    if (done)
	  //     break;
  }
  XML_ParserFree(p);
	printf("\n");
	printf("Parsed all XML-Data...\n\n");
	fclose(xml_datei);
	fclose(gmn_datei);
	if (!found_unknown) {
		fprintf(unknown_tags, "No unknown tags found in %s", xml_datei_name);
	}
	else { 	printf("\nFound unknown tags, see list in %s.\nAll unknown tags are parsed an a standard way:\n\\tag<param1=value1,...,paramX=valueX>", unknown_tags_name);}
	fclose(unknown_tags);
	
	return 0;
}  /* End of main */

